'==============================================================================
' GUI Creator.bas
' Erstellt am 09.12.2011
'==============================================================================

'compilieren mit -s gui

#INCLUDE "Inc\SCROLL.bas"
#INCLUDE "File.bi"

DIM AS STRING Path_to_FBProgs, Path_to_GUIbi, Datei, s1(100), s2(), v(), Hilf, _
  Type_v(), jn
DIM AS INTEGER row, Fehler, f, i, k, n, MenuExist

WINDOWTITLE "GUI Creator fuer sGUI"
SCREENRES 80 * 8, 50 * 16
WIDTH 80, 50
COLOR 0, 15
CLS

'Config-File oeffnen:
f = FREEFILE
OPEN "GUI Creator.ini" FOR INPUT AS #f
IF ERR <> 0 THEN
  PRINT "Konfigurationsdatei 'GUI Creator.ini' nicht gefunden!"
  PRINT "Beliebige Taste druecken zum Beenden!"
  GETKEY
  END
ELSE
  INPUT #f, Path_to_FBProgs
  INPUT #f, Path_to_GUIbi
  CLOSE #f
END IF

'Hilfe-Information anzeigen:
PRINT "Text und Elemente fuer ein GUI definieren. Syntax:"
PRINT
PRINT "Einfaches Pulldown-Menue:"
PRINT "-------------------------"
PRINT "Menueheader:    Menu(event, 1, 0, 1, mname)" 
PRINT "Menue-Eintrag:  <Bezeichner> = Menu(event, 1, entryID, 1, mname), entryID >= 1"
PRINT
PRINT "Text:"
PRINT "-----"
PRINT "DRAW STRING(x, y), Text"
PRINT
PRINT "Buttons, Eingabefelder usw.:"
PRINT "----------------------------"
PRINT "<Bezeichner> = AddSimpleGadget(Parameter)"
PRINT "<Bezeichner> = AddStringGadget(Parameter)"
PRINT "<Bezeichner> = (entsprechende Add-Funktion von sGUI)"
PRINT
PRINT "'Menu', 'event' und 'Add' sind reservierte (Teil)strings und duerfen nicht"
PRINT "in den Bezeichnern vorkomen! Der Parameter 'event' darf nicht anders"
PRINT "bezeichnet werden, das Programm erzeugt einen Eventloop mit genau diesem"
PRINT "Eventhandler."
PRINT

'Eingabe:
PRINT "Eingabe beenden mit ESC:"
row = CSRLIN
VIEW PRINT row TO row + 9
COLOR 0, 7
CLS
EditText(s1())
VIEW PRINT 
COLOR 0, 15

'Alle relevanten Eintraege herausfiltern (ohne leere Strings):
i = 0
n = 0
DO
  IF s1(i) <> "" THEN
    REDIM PRESERVE s2(n)
    s2(n) = s1(i)
    n = n + 1
  END IF
  IF i < 100 THEN i = i + 1
LOOP UNTIL i = 100
n = UBOUND(s2)
  
'Alle Variablen und ihre Typen erzeugen:
REDIM v(n), Type_v(n)
FOR i = 0 TO n
  Hilf = UCASE(s2(i))
  IF INSTR(Hilf, "MENU") > 0 THEN MenuExist = 1
  k = INSTR(s2(i), "=")
  IF k > 1 THEN
    v(i) = TRIM(LEFT(s2(i), k - 1))
    IF INSTR(Hilf, "ADD") > 0 THEN Type_v(i) = "Gadget PTR"
    IF INSTR(Hilf, "MENU") > 0 THEN Type_v(i) = "INTEGER"
  END IF
NEXT i

'Codedatei eingeben:
Datei = Path_to_FBProgs + "*.bas"
DO
  
  Fehler = 0
  DO
    LOCATE row + 11
    PRINT "Code exportieren nach: ";
    Edit(Datei)
    IF FILEEXISTS(Datei) THEN
      PRINT "Datei bereits vorhanden - ueberschreiben j/n: ";
      Edit(jn)
    END IF
  LOOP UNTIL LCASE(jn) = "j" OR FILEEXISTS(Datei) = 0
  
  f = FREEFILE
  OPEN Datei FOR OUTPUT AS #f
  IF ERR <> 0 THEN
    Fehler = ERR
    PRINT "Pfad nicht gefunden!"
  END IF
    
LOOP UNTIL Fehler = 0

'Code erzeugen und speichern:
PRINT #f, "#INCLUDE "; CHR(34); Path_to_GUIbi; CHR(34)
PRINT #f,
PRINT #f, "SCREENRES 80 * 8, 16 * 30, 32"
PRINT #f, "WIDTH 80, 30"
PRINT #f,
PRINT #f, "InitGFX"
PRINT #f,
PRINT #f, "DIM AS EventHandle PTR event"
PRINT #f, "event = CreateEventHandle"
PRINT #f,
FOR i = 0 TO n
  IF Type_v(i) = "INTEGER" THEN PRINT #f, "DIM "; v(i); " AS INTEGER"
  IF Type_v(i) = "Gadget PTR" THEN PRINT #f, "DIM "; v(i); " AS Gadget PTR"
NEXT i
PRINT #f, 
FOR i = 0 TO n
  'alle GUI-Elemente wie eingegeben:
  PRINT #f, s2(i)
NEXT i
PRINT #f,
IF MenuExist <> 0 THEN PRINT #f, "MenuOn(event)"
FOR i = 0 TO n
  IF Type_v(i) = "Gadget PTR" THEN PRINT #f, "GadgetOn("; v(i); ")"
NEXT i
PRINT #f,
PRINT #f, "DO"
PRINT #f,
PRINT #f, "  event -> xSleep(1)"
IF MenuExist <> 0 THEN
  PRINT #f,
  PRINT #f, "  IF event-> MENUMESSAGE THEN"
  PRINT #f, "    SELECT CASE event-> MENUMESSAGE"
  FOR i = 0 TO n
    IF Type_v(i) = "INTEGER" THEN 
      PRINT #f, "      CASE "; v(i)
      PRINT #f, "        'Code ...'"
    END IF
  NEXT i
  PRINT #f, "    END SELECT"
  PRINT #f, "  END IF"
END IF
PRINT # f,
PRINT #f, "  IF event-> GADGETMESSAGE THEN"
PRINT #f, "    SELECT CASE event-> GADGETMESSAGE"
FOR i = 0 TO n
  IF Type_v(i) = "Gadget PTR" THEN
    PRINT #f, "      CASE "; v(i)
    PRINT #f, "        'Code ...'"
  END IF
NEXT i
PRINT #f, "    END SELECT"
PRINT #f, "  END IF"
PRINT #f,
PRINT #f, "LOOP UNTIL event-> EXITEVENT"
PRINT #f,   
PRINT #f, "DestroyEventHandle (event)"
PRINT #f,
PRINT #f, "END"
PRINT #f,
CLOSE #f

PRINT "Code exportiert - Beliebige Taste druecken zum Beenden!"
GETKEY

