'===============================================================================
' SCROLL.bas
' Scrollfunktionen im Fenster (dieses muss vorher mit VIEW PRINT gesetzt sein!)
' Erstellt am 26.11.2011
' Letzte Bearbeitung am 04.12.11
'===============================================================================


#INCLUDE ONCE "TUI.bas"


DECLARE SUB Scrollbar(RelPos AS SINGLE)
DECLARE SUB ViewText(s() AS STRING)
DECLARE SUB EditText(s() AS STRING)
DECLARE SUB SelectItem(s() AS STRING, BYREF sNr AS INTEGER)


PRIVATE SUB Scrollbar(RelPos AS SINGLE)
' Senkrechter Scrollbalken am rechten Fensterrand. RelPos = Relative Position der
' Markierung.
  
  DIM AS INTEGER Startzeile, Endzeile, Hoehe, Spalte, i, k
  
  Startzeile = LOWORD(VIEW PRINT())
  Endzeile = HIWORD(VIEW PRINT())
  Spalte = LOWORD(WIDTH)
  Hoehe = Endzeile - Startzeile + 1 
  
  k = INT((Hoehe - 3) * RelPos)
      
  'Pfeil nach oben:
  LOCATE Startzeile, Spalte 
  PRINT CHR(30);
  'Pfeil nach unten
  LOCATE Endzeile, Spalte
  PRINT CHR(31);
  'Balken mit Positionsmarkierung:
  FOR i = 0 TO Hoehe - 3
    LOCATE Startzeile + i + 1, Spalte
    IF i = k THEN PRINT CHR(219); ELSE PRINT CHR(176);
  NEXT i
  
END SUB


SUB ViewText(s() AS STRING)
' Scrollen von Text s(0) bis s(n) mit den Cursortasten auf/ab im Fenster ohne
' Editieren. Beenden mit ESC. 
  
  DIM AS INTEGER Startzeile, Endzeile, Hoehe, i, k, n = UBOUND(s), key
    
  Startzeile = LOWORD(VIEW PRINT())
  Endzeile = HIWORD(VIEW PRINT())
  Hoehe = Endzeile - Startzeile + 1
    
  k = 0
  DO
    
    'Text mit Scrollbar:
    CLS 2
    FOR i = k TO Hoehe - 1 + k
      LOCATE Startzeile + i - k, 1, 0 'normalen Cursor aus
      PRINT LEFT(s(i), LOWORD(WIDTH) - 1);
    NEXT i
    LOCATE Startzeile, LOWORD(WIDTH)
    Scrollbar(k / (n - Hoehe))
        
    'Tastendruck auswerten:
    key = GETKEY
    SELECT CASE key
    CASE SC_ESC
      LOCATE ,, 1   'normalen Cursor wieder ein
      EXIT SUB
    CASE SC_UP
      IF k > 0 THEN k = k - 1
    CASE SC_DOWN
      IF k <= n - Hoehe THEN k = k + 1
    END SELECT
  
  LOOP
  
END SUB


SUB EditText(s() AS STRING)
' Editieren von Text im Fenster. Alle s(i) muessen auf eine Zeile passen! 
' Beenden mit ESC.
  
  DIM AS INTEGER Startzeile, Endzeile, Hoehe, i, j, k, n = UBOUND(s), ExitCode
  
  Startzeile = LOWORD(VIEW PRINT())
  Endzeile = HIWORD(VIEW PRINT())
  Hoehe = Endzeile - Startzeile + 1 
    
  k = 0
  j = 0
  DO
    
    'Text mit Scrollbar anzeigen:
    CLS 2
    FOR i = k TO Hoehe - 1 + k
      LOCATE Startzeile + i - k, 1
      PRINT s(i);
    NEXT i
    LOCATE Startzeile, LOWORD(WIDTH)
    Scrollbar(k / (n - Hoehe))
        
    'Editieren:
    LOCATE Startzeile + j - k, 1
    InString(s(j), LOWORD(WIDTH) - 2, ExitCode)
    SELECT CASE ExitCode
    CASE SC_DOWN, SC_ENTER
      'Eine Zeile weiter:
      IF j < n THEN j = j + 1
      IF j = Hoehe + k THEN
        IF k <= n - Hoehe THEN k = k + 1
      END IF
    CASE SC_UP
      'Eine Zeile zurueck:
      IF j > 0 THEN j = j - 1
      IF j = k THEN
        IF k > 0 THEN k = k - 1
      END IF
    CASE SC_ESC
      'Ende:
      EXIT DO
    END SELECT
        
  LOOP
  
END SUB
      

SUB SelectItem(s() AS STRING, BYREF sNr AS INTEGER)
' Auswahl s(0) bis s(n), sNr = Nummer des gewaehlten Eintrages.
  
  DIM AS INTEGER Startzeile, Endzeile, Hoehe, i, j, k, n = UBOUND(s), key, _
    fgcolor, bkcolor
  
  Startzeile = LOWORD(VIEW PRINT())
  Endzeile = HIWORD(VIEW PRINT())
  Hoehe = Endzeile - Startzeile + 1 
  fgcolor = LOWORD(COLOR)
  bkcolor = HIWORD(COLOR)
    
  k = 0
  j = 0
  DO
    
    'Auswahl mit Scrollbar anzeigen:
    CLS 2
    FOR i = k TO Hoehe - 1 + k
      IF j = i THEN 
        IF bkcolor = 7 OR bkcolor = 15 THEN COLOR 15, 3 ELSE COLOR 0, 7
      ELSE
        COLOR fgcolor, bkcolor
      END IF
      LOCATE Startzeile + i - k, 1, 0 'Cursor aus
      PRINT LEFT(s(i), LOWORD(WIDTH) - 1);
      COLOR fgcolor, bkcolor  'muss ein, sonst gibt es Problem, wenn der Menubalken ganz unten war
    NEXT i
    LOCATE Startzeile, LOWORD(WIDTH)
    Scrollbar(k / (n - Hoehe))
        
    'Auswaehlen:
    key = GETKEY
    SELECT CASE key
    CASE SC_DOWN
      'Eine Zeile weiter:
      IF j < n THEN j = j + 1
      IF j = Hoehe + k THEN
        IF k <= n - Hoehe THEN k = k + 1
      END IF
    CASE SC_UP
      'Eine Zeile zurueck:
      IF j > 0 THEN j = j - 1
      IF j = k THEN
        IF k > 0 THEN k = k - 1
      END IF
    CASE SC_ENTER
      'Ende:
      sNr = j
      LOCATE ,,1  'Cursor wieder ein
      EXIT DO
    END SELECT
    
  LOOP
  
END SUB
      


